function lsd.get_module_chat()
	local chat = lsd.get_module_prototype('chat')

	chat.color_rng = SmoothRandomColor:create_rng(0.5)

	--Intercept the original chatreceiver.OnEvent with our own, where we'll insert the colors
	chat.original_OnEvent = chatreceiver.OnEvent
	function chat:OnEvent(event, data)
		--data has msg, name, and faction, channelid (but not always!)
		if data ~= nil then
			if data.channelid ~= nil then
				local color = lsd.get_module_by_name('chat').color_rng:get_ascii()
				if color ~= nil then
					data.msg = color .. data.msg .. '\127o'
				end
			end
		end
		lsd.get_module_by_name('chat'):original_OnEvent(event, data)
	end
	
	function chat:enable()
		self.enabled = true
		chatreceiver.OnEvent = self.OnEvent
	end
	
	function chat:disable()
		chatreceiver.OnEvent = self.original_OnEvent
		self.enabled = false
	end
	
	
	
	return chat
end

lsd.add_module(lsd.get_module_chat())
