function lsd.get_module_fov()
	local fov = lsd.get_module_prototype('fov')

	fov.delay = 50

	--fov.a_rng = PseudoPerlin:create_rng(0.02, 0.4, 3)
	fov.rng = PseudoPerlin:create_rng(0.003, 0.4, 3)
	
	fov.intro = true
	fov.orig = Game.GetCVar('fov')
	fov.current = fov.orig
	fov.desired = fov.orig
	fov.min = fov.orig - 20
	fov.max = fov.orig + 40
	fov.tmp = 0
	
	function fov:update_val()
		local a = self.rng:get()
		self.desired = (self.max-self.min)*a + self.min
		return(self.desired)
	end
	
	function fov:cubic_interp(s, e, x)
		return( 2*(s-e)*x^3 - 3*(s-e)*x^2 + s)
	end
	
	function fov:action()
		if self.intro then
			local delta = 0.025
			self.tmp = self.tmp + delta
			self.current = self:cubic_interp(self.orig, self.desired, self.tmp)
			gkinterface.SetFOV(self.current)
			if self.tmp >= 1 then
				self.intro = false
			end
		else
			self:update_val()
			gkinterface.SetFOV(self.desired)
		end
	end
	
	function fov:enable_cb()
		self.intro = true
		self.tmp = 0
		self:update_val()
	end
	
	function fov:disable_cb()
		gkinterface.SetFOV(self.orig)
	end
	
	return fov
end

lsd.add_module(lsd.get_module_fov())
