function lsd.get_module_hippo()
	local hippo = lsd.get_module_prototype()
	
	hippo.delay = 50

	hippo.x_rng = PseudoPerlin:create_rng(0.01, 0.4, 5)
	hippo.y_rng = PseudoPerlin:create_rng(0.01, 0.4, 5)
	
	hippo.images={
		"plugins/lsd/img/awesome2R.png",
		"plugins/lsd/img/awesome2Y.png",
		"plugins/lsd/img/awesome2G.png",
		"plugins/lsd/img/awesome2B.png",
		"plugins/lsd/img/awesome2P.png",
		"plugins/lsd/img/awesome3R.png",
		"plugins/lsd/img/awesome3Y.png",
		"plugins/lsd/img/awesome3G.png",
		"plugins/lsd/img/awesome3B.png",
		"plugins/lsd/img/awesome3P.png",
		"plugins/lsd/img/awesome4R.png",
		"plugins/lsd/img/awesome4Y.png",
		"plugins/lsd/img/awesome4G.png",
		"plugins/lsd/img/awesome4B.png",
		"plugins/lsd/img/awesome4P.png",
	}
	hippo.width = 256
	hippo.height = 256
	hippo.position = { 0, 0 }
	hippo.velocity = { 1, 0 }
	hippo.motion = 'random'
	hippo.alive = true
	hippo.allowed_off_screen = false
	hippo.life_timer = Timer()

	function hippo:get_random_image()
		return self.images[math.random(#self.images)]
	end

	function hippo:set_random_image()
		local img = self:get_random_image()
		self.dlg[1].image = img
	end

	function hippo:set_position(x,y)
		self.position[1] = x
		self.position[2] = y
	end

	function hippo:set_velocity(x,y)
		self.velocity[1] = x
		self.velocity[2] = y
	end

	function hippo:get_speed()
		return (math.sqrt(self.velocity[1]^2 + self.velocity[2]^2))
	end
	
	function hippo:is_moving()
		if self.velocity[1] ~= 0 or self.velocity[2] ~= 0  then
			return true
		else
			return false
		end
	end
	
	function hippo:is_on_screen(actual)
		if (actual == nil or actual == false) and self.allowed_off_screen then
			return true
		end
		
		local margin = 10
		if self.position[1] < 0 - self.width - margin or self.position[1] > lsd.screen_width + margin then
			return false
		end
		if self.position[2] < 0 - self.height - margin or self.position[2] > lsd.screen_height + margin then
			return false
		end
		
		return true
	end
	
	function hippo:set_lifetime(t)
		self.life_timer:SetTimeout(t, function() self.alive = false end)
	end

	function hippo:linear_motion()
		self.position[1] = self.position[1] + self.velocity[1]
		self.position[2] = self.position[2] + self.velocity[2]
		ShowDialog(self.dlg, self.position[1], self.position[2])
		if not self:is_on_screen() then
			self.alive = false
		end
	end

	function hippo:random_motion()
		local xr = self.x_rng:get()
		local yr = self.y_rng:get()
		local x = math.floor((xr * lsd.screen_width) - (self.width/2))
		local y = math.floor((yr * lsd.screen_height) - (self.height/2))
		ShowDialog(self.dlg, x, y)
	end

	function hippo:action()
		if self.motion == 'linear' then
			self:linear_motion()
		elseif self.motion == 'random' then
			self:random_motion()
		end
	end

	function hippo:disable_cb()
		self.life_timer:Kill()
		HideDialog(self.dlg)
	end

	function hippo:destroy()
		self:disable()
		iup.Destroy(self.dlg)
	end

	hippo.dlg = iup.dialog {
		iup.label{title="", image=hippo:get_random_image()};
		border="NO";
		resize="NO";
		maxbox="NO";
		minbox="NO";
		menubox="NO";
		active="NO";
		topmost="NO";
		bgcolor="0 0 0 0 *";
	}

	return hippo
end
