dofile('hippo.lua')

function lsd.get_module_hf()
	local hf = lsd.get_module_prototype('hf')
	
	hf.delay = 2000
	
	hf.max_hippos = 3
	hf.hippos = {}

	function hf:create_hippo(id)
			hf.hippos[id] = lsd.get_module_hippo()
			hf.hippos[id].motion = 'linear'
			hf.hippos[id]:set_velocity(math.random(20)-10, math.random(20)-10)
			self:position_along_edge(id)
			if not hf.hippos[id]:is_moving() then
				hf.hippos[id]:set_lifetime(4000)
			end
			hf.hippos[id]:enable()
	end
	
	function hf:destroy_hippo(id)
		self.hippos[id]:destroy()
		self.hippos[id] = nil
	end

	function hf:position_along_edge(id)
		local w = lsd.screen_width
		local h = lsd.screen_height
		local vx = hf.hippos[id].velocity[1]
		local vy = hf.hippos[id].velocity[2]
		local x,y
		if math.abs(vx) > math.abs(vy) then
			if vx > 0 then
				x = -hf.hippos[id].width
			else
				x = w
			end
			if vy > 0 then
				y = h/2 * math.random()
			else
				y = 3*h/2 * math.random()
			end
		else
			if vy > 0 then
				y = -hf.hippos[id].height
			else
				y = h
			end
			if vx > 0 then
				x = w/2 * math.random()
			else
				x = 3*w/2 * math.random()
			end
		end
		hf.hippos[id]:set_position(x,y)
	end

	function hf:action()
		if #hf.hippos < hf.max_hippos then
			self:create_hippo(#hf.hippos+1)
		end
		
		for id,hippo in pairs(self.hippos) do
			if not hippo.alive then
				self:destroy_hippo(id)
				self:create_hippo(id)
			end
		end
	end

	function hf:disable_cb()
		for id,hippo in pairs(self.hippos) do
			self:destroy_hippo(id)
		end
	end

	return hf
end

lsd.add_module(lsd.get_module_hf())
