function lsd.get_module_prototype(name)
	local prototype = {}
	prototype.enabled = false
	prototype.delay = 100
	prototype.timer = Timer()
	prototype.id = nil
	prototype.name = name

	function prototype:set_active(state)
		if state then
			self:enable()
		else
			self:disable()
		end
	end

	function prototype:toggle()
		if self.enabled then
			self:disable()
		else
			self:enable()
		end
	end

	function prototype:enable_cb()
		return
	end

	function prototype:enable()
		self.enabled = true
		self:enable_cb()
		self:run()
	end

	function prototype:disable_cb()
		return
	end

	function prototype:disable()
		self.enabled = false
		self.timer:Kill()
		self:disable_cb()
	end

	function prototype:run()
		if self.enabled then
			self:action()
			self.timer:SetTimeout(self.delay, function() self:run() end)
		end
	end

	function prototype:action()
		print('Function not yet defined.')
	end

	return(prototype)
end


